import typing

import bpy

from .slt_utils import PrecisionOperatorMixin


class SLT_OT_rebevel(PrecisionOperatorMixin, bpy.types.Operator):
    bl_idname = "smart_loops_toolkit.rebevel"
    bl_label = "Rebevel"
    bl_description = 'Rebevel loops'
    bl_options = {'REGISTER', 'UNDO'}

    def execute_with_precision(self, context: bpy.context) -> typing.Union[typing.Set[int], typing.Set[str]]:
        bpy.ops.smart_loops_toolkit.unbevel()
        bpy.ops.mesh.bevel('INVOKE_DEFAULT')
        return {'FINISHED'}
