import bpy


class VIEW3D_PT_tools_smart_loops_toolkit(bpy.types.Panel):
    bl_label = 'Smart Loops Toolkit'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = 'Edit'
    bl_context = "mesh_edit"
    bl_options = {'HEADER_LAYOUT_EXPAND'}

    def draw(self, context: bpy.context) -> None:
        self.layout.operator('smart_loops_toolkit.align_view', text='Align View to Selection')
        self.layout.operator('smart_loops_toolkit.subdivide_loops', text='Subdivide Loops')
        self.layout.operator('smart_loops_toolkit.unsubdivide_loops', text='Unsubdivide Loops')
        self.layout.operator('smart_loops_toolkit.fix_ngons', text='Fix ngons')
        self.layout.operator('smart_loops_toolkit.recalculate_loop', text='Recalculate Loop')
        self.layout.operator('smart_loops_toolkit.straighten_loops', text='Straighten Loops')
        self.layout.operator('smart_loops_toolkit.straighten_faces', text='Straighten Faces')
        self.layout.operator('smart_loops_toolkit.unbevel', text='Unbevel')
        self.layout.operator('smart_loops_toolkit.rebevel', text='Rebevel')


class VIEW3D_MT_edit_mesh_smart_loops_toolkit(bpy.types.Menu):
    bl_label = 'Smart Loops Toolkit'

    def draw(self, context: bpy.context) -> None:
        self.layout.operator('smart_loops_toolkit.align_view', text='Align View to Selection')
        self.layout.operator('smart_loops_toolkit.subdivide_loops', text='Subdivide Loops')
        self.layout.operator('smart_loops_toolkit.unsubdivide_loops', text='Unsubdivide Loops')
        self.layout.operator('smart_loops_toolkit.fix_ngons', text='Fix ngons')
        self.layout.operator('smart_loops_toolkit.recalculate_loop', text='Recalculate Loop')
        self.layout.operator('smart_loops_toolkit.straighten_loops', text='Straighten Loops')
        self.layout.operator('smart_loops_toolkit.straighten_faces', text='Straighten Faces')
        self.layout.operator('smart_loops_toolkit.unbevel', text='Unbevel')
        self.layout.operator('smart_loops_toolkit.rebevel', text='Rebevel')


def menu_func(self, _: bpy.context) -> None:
    self.layout.menu("VIEW3D_MT_edit_mesh_smart_loops_toolkit")
    self.layout.separator()
